## xrprof 0.3.1

=== Makefile ===
VERSION = 0.3.1

CFLAGS = -O2 -Wall -fPIC -mno-ms-bitfields -g
LIBS = -lelf -lunwind-ptrace -lunwind-generic

BIN = xrprof
BINOBJ = src/xrprof.o
OBJ = src/cursor.o \
  src/locate.o \
  src/memory.o \
  src/process.o
SHLIB = libxrprof.so

all: $(BIN)

clean:
	$(RM) $(BIN) $(BINOBJ) $(OBJ) $(SHLIB)
	cd tests && $(MAKE) clean

$(BIN): $(OBJ) $(BINOBJ)
	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)

shlib: $(SHLIB)

$(SHLIB): $(OBJ)
	$(CC) $(LDFLAGS) -shared -o $@ $^

src/cursor.o: src/cursor.c src/cursor.h src/rdefs.h src/locate.h src/memory.h
	$(CC) $(CFLAGS) -c -o $@ $<

src/locate.o: src/locate.c src/locate.h src/memory.h
	$(CC) $(CFLAGS) -c -o $@ $<

src/memory.o: src/memory.c src/memory.h src/rdefs.h
	$(CC) $(CFLAGS) -c -o $@ $<

src/process.o: src/process.c
	$(CC) $(CFLAGS) -c -o $@ $<

src/xrprof.o: src/xrprof.c src/cursor.h
	$(CC) $(CFLAGS) -c -o $@ $<

test: $(BIN)
	cd tests && $(MAKE) "BIN=../$(BIN)"

# Mostly compatible with https://www.gnu.org/prep/standards/html_node/Makefile-Conventions.html
INSTALL = install
prefix ?= /usr/local
bindir = $(prefix)/bin
datadir = $(prefix)/share
includedir = $(prefix)/include
libdir = $(prefix)/lib

install:
	$(INSTALL) -d $(DESTDIR)$(bindir)
	$(INSTALL) -T -m 0755 $(BIN) $(DESTDIR)$(bindir)/$(BIN)
	$(INSTALL) -d $(DESTDIR)$(datadir)/man/man1
	$(INSTALL) -T -m 0755 docs/$(BIN).1 $(DESTDIR)$(datadir)/man/man1/$(BIN).1
	setcap cap_sys_ptrace=eip $(DESTDIR)$(bindir)/$(BIN) || exit 0

install-shlib:
	$(INSTALL) -d $(DESTDIR)$(libdir)
	$(INSTALL) -T -m 0644 $(SHLIB) $(DESTDIR)$(libdir)/$(SHLIB)

PACKAGE = $(BIN)
DISTDIR = $(PACKAGE)-$(VERSION)

dist:
	$(INSTALL) -d $(DISTDIR)
	$(RM) -r $(DISTDIR)/*
	$(INSTALL) -d $(DISTDIR)/src
	cp src/*.c src/*.h $(DISTDIR)/src
	$(INSTALL) -d $(DISTDIR)/docs
	cp docs/* $(DISTDIR)/docs
	cp Makefile README.md NEWS.md $(DISTDIR)/
	tar -czf $(DISTDIR).tar.gz $(DISTDIR)
	$(RM) -r $(DISTDIR)
	sha256sum $(DISTDIR).tar.gz > $(DISTDIR).tar.gz.sha256

distclean:
	$(RM) $(BIN) $(BINOBJ) $(OBJ) $(SHLIB)

.PHONY: all clean test install dist distclean

=== debian/changelog ===
xrprof (0.3.1-2) unstable; urgency=medium

  * Sync with upstream for updated Makefile

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 22 Feb 2021 15:39:53 -0600

xrprof (0.3.1-1) unstable; urgency=medium

  * New upstream release, initial Debian upload		(closes: #981064)

  * debian/patches: No longer required after upstream PR merged

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 25 Jan 2021 15:03:45 -0600

xrprof (0.3.0-2) unstable; urgency=medium

  * Makefile: minor patches

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 23 Jan 2021 16:23:41 -0600

xrprof (0.3.0-1) unstable; urgency=low

  * Initial build

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 23 Jan 2021 15:55:49 -0600

=== debian/control ===
Source: xrprof
Section: math
Priority: optional
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Build-Depends: debhelper-compat (= 11), libelf-dev, libunwind-dev
Standards-Version: 4.5.1
Homepage: https://github.com/atheriel/xrprof

Package: xrprof
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: External Sampling Profiler for R
 xrprof (formerly rtrace) is an external sampling profiler for R on
 Linux and Windows.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- prefix=/usr

override_dh_auto_install:
	dh_auto_install -- prefix=/usr

override_dh_auto_test:
	echo "Skipping checks for now"

override_dh_usrlocal:
	echo "Skipping"

=== debian/watch ===
version=3
https://github.com/atheriel/xrprof/releases/download/v.+/xrprof-(.+)\.tar\.gz
